#include <iostream>
#include <vector>
#include <map>
#include <string>
#include "alan/stuff.h"
#include "alan/c3_obj.h"

alan::obj func(alan::obj in)
{
	if (in.get_member<alan::obj>("owner").member_exists("member_exists"))
	{
		std::cout<<in.get_member<alan::obj>("owner").get_member<std::string>("string") + in.get_member<std::string>("extent")<<std::endl;
	}
	else
	{
		alan::stuff::error("requirements not met");
	}
	return alan::obj();
}

void main()
{
	alan::obj o1;
	std::cout<<"made the object 'o1'"<<std::endl<<std::endl;
	o1.add_member_obj("string", std::string("the default string"));
	o1.add_member_func("extend string", &func);
	std::cout<<"added 'string' and 'extend string' members to 'o1', 'string' is: "<<std::endl;
	std::cout<<"'"<<o1.get_member<std::string>("string")<<"'"<<std::endl<<std::endl;
	if (o1.member_exists("string"))
	{
		std::cout<<"'o1' has a member called 'string'"<<std::endl;
	}
	else
	{
		std::cout<<"'o1' does not have a member called 'string'"<<std::endl;
	}
	if (o1.member_exists("volume"))
	{
		std::cout<<"'o1' has a member called 'volume'"<<std::endl;
	}
	else
	{
		std::cout<<"'o1' does not have a member called 'volume'"<<std::endl;
	}
	std::cout<<std::endl<<"called 'extend string' with one parameter called 'extent' which was ' :-)'"<<std::endl<<"'string' is now"<<std::endl;
	o1.call<std::string>("extend string", "extent", std::string(" :-)"));
	std::cout<<"'"<<o1.get_member<std::string>("string")<<"'"<<std::endl; // dosn't work yet as get_member gets a copy not a pointer or referance
}